<html lang="en">
<head>
<title>Swept objects - Sketch</title>
<meta http-equiv="Content-Type" content="text/html">
<meta name="description" content="Sketch">
<meta name="generator" content="makeinfo 4.7">
<link title="Top" rel="start" href="index.html#Top">
<link rel="up" href="Introduction-by-example.html#Introduction-by-example" title="Introduction by example">
<link rel="prev" href="Repeated-objects.html#Repeated-objects" title="Repeated objects">
<link href="http://www.gnu.org/software/texinfo/" rel="generator-home" title="Texinfo Homepage">
<!--
Copyright (C) 2005, 2006, 2007, 2008 Eugene K. Ressler.

This manual is for `sketch', version 0.2 (build 161),
Tuesday, September 08, 2009, a program that converts descriptions of simple
three-dimensional scenes into static drawings. This version generates
`PSTricks' or `PGF/TikZ' code suitable for use with the
TeX document processing system.

`Sketch' is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 3, or (at your option)
any later version.

Sketch is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with `sketch'; see the file COPYING.txt.  If not, see
http://www.gnu.org/copyleft.-->
<meta http-equiv="Content-Style-Type" content="text/css">
<style type="text/css"><!--
  pre.display { font-family:inherit }
  pre.format  { font-family:inherit }
  pre.smalldisplay { font-family:inherit; font-size:smaller }
  pre.smallformat  { font-family:inherit; font-size:smaller }
  pre.smallexample { font-size:smaller }
  pre.smalllisp    { font-size:smaller }
  span.sc { font-variant:small-caps }
  span.roman { font-family: serif; font-weight: normal; } 
--></style>
</head>
<body>
<div class="node">
<p>
<a name="Swept-objects"></a>Previous:&nbsp;<a rel="previous" accesskey="p" href="Repeated-objects.html#Repeated-objects">Repeated objects</a>,
Up:&nbsp;<a rel="up" accesskey="u" href="Introduction-by-example.html#Introduction-by-example">Introduction by example</a>
<hr><br>
</div>

<!-- node-name,  next,  previous,  up -->
<h3 class="section">2.7 Swept objects</h3>

<p><a name="index-swept-object-91"></a><a name="index-sweep-92"></a>Many familiar shapes can be generated by sweeping simpler ones through
space and considering the resulting path, surface, or volume. 
<code>Sketch</code> implements this idea in the <tt>sweep</tt> command. 
<a name="index-sweep-93"></a><a name="index-rotate-94"></a>
<pre class="verbatim">
  def n_segs 8
  sweep { n_segs, rotate(180 / n_segs, (0,0,0), [0,0,1]) } (1,0,0)
</pre>
This code sweeps the point (1,0,0)
<a name="index-point-sweep-95"></a><a name="index-swept-point-96"></a>eight times by rotating it
180/8 = 22.5 degrees each time and connecting the resulting
points with line segments.  The <tt>def</tt> used here is a
<dfn>scalar</dfn> definition. 
<a name="index-definition_002c-scalar-97"></a><a name="index-scalar-definition-98"></a>References to
<a name="index-reference_002c-scalar-99"></a>scalars have no enclosing brackets at all.

<ul class="menu">
<li><a accesskey="1" href="Point-sweeps.html#Point-sweeps">Point sweeps</a>:                 Swept points make lines and polygons. 
<li><a accesskey="2" href="Polyline-sweeps.html#Polyline-sweeps">Polyline sweeps</a>:              Swept lines make surfaces. 
<li><a accesskey="3" href="Nested-sweeps.html#Nested-sweeps">Nested sweeps</a>:                Swept sweeps are useful! 
<li><a accesskey="4" href="Polygon-sweeps.html#Polygon-sweeps">Polygon sweeps</a>:               Swept polygons make solids... 
<li><a accesskey="5" href="Polyline-sweeps-with-closure.html#Polyline-sweeps-with-closure">Polyline sweeps with closure</a>:   and so do closed polyline sweeps. 
<li><a accesskey="6" href="Affine-arithmetic.html#Affine-arithmetic">Affine arithmetic</a>:            Sketch useful math expression. 
<li><a accesskey="7" href="More-to-learn.html#More-to-learn">More to learn</a>:                Check out the Mobius strip! 
</ul>

   </body></html>

